Max Sum of Max-K-sub-sequence----单调队列

至于题是哪来的,老师BB出来的
至于怎么BB的,请自己联想
我洛谷上的博客

Max Sum of Max-K-sub-sequence

Given a circle sequence A[1],A[2],A[3]…A[n]. Circle sequence means the left neighbour of A[1] is A[n] , and the right neighbour of A[n] is A[1].
Now your job is to calculate the max sum of a Max-K-sub-sequence. Max-K-sub-sequence means a continuous non-empty sub-sequence which length not exceed K.

Input

The first line of the input contains an integer T(1<=T<=100) which means the number of test cases.
Then T lines follow, each line starts with two integers N , K(1<=N<=100000 , 1<=K<=N), then N integers followed(all the integers are between -1000 and 1000).

Output

For each test case, you should output a line contains three integers, the Max Sum in the sequence, the start position of the sub-sequence, the end position of the sub-sequence. If there are more than one result, output the minimum start position, if still more than one , output the minimum length of them.

Sample Input

4
6 3
6 -1 2 -6 5 -5
6 4
6 -1 2 -6 5 -5
6 3
-1 2 -6 5 -5 6
6 6
-1 -1 -1 -1 -1 -1

Sample Output

7 1 3
7 1 3
7 6 2
-1 1 1

题意自己百度

这道题,可以这样做

解释都在注释和下面
`

由于是一个圈
1 2 3 4 5
显然1的左边还有5
那么我们就把问题分为两类
第一类:
	就是一个没有跨过了n的序列
第二类:
	一个跨过了n的序列`

第一类

题意可转换为
有一序列
在其中找一个长度不超过k的子序列使其和最大
有多个子序列满足条件的按题意输出
就用。。。

第二类

在整个序列中找一子序列,使其总和最小且长度大于等于n - k
ans = ALL - 子序列总和

是不是很简单( ⊙ o ⊙ )啊!

#include <cstdio>
#include <climits>
const int MAXN = 100001;
class MYOWN
{
	public:
		int val,it;
		MYOWN()
		{
			val = 0;
			it = 0;
		}
};
int main()
{
	int T;
	scanf("%d",&T);
	//多组数据
	while(T--)
	{
		int i,n,k,head,tail,ALL = 0;
		/*
		显然head记录队头,tail记录队尾
		ALL方便第二种
		*/
		int num[MAXN] = {},sum[MAXN] = {};
		int ans = -1001,l,r;
		MYOWN q[MAXN];
		scanf("%d%d",&n,&k);
		for(i = 1;i <= n;i++)
		{
			scanf("%d",&num[i]);
			sum[i] = sum[i - 1] + num[i];
			ALL += num[i];
		}
		head = 1;tail = 1;
		for(i = 1;i <= n;i++)
		{
			while(q[head].it < i - k&&head <= tail)
				head++;
			int delta = sum[i] - q[head].val;
			if(delta > ans)
			{
				ans = delta;
				l = q[head].it + 1;
				r = i;
			}
			while(sum[i] <= q[tail].val&&tail >= head)
				tail--;
			tail++;
			q[tail].val = sum[i];
			q[tail].it = i;
		}
		//第一类,单调队列嘛
		k = n - k;
		q[0].val = -1001;
		for(i = 1;i <= n;i++)
		{
			if(sum[i] <= q[i - 1].val)
			{
				q[i].it = q[i - 1].it;
				q[i].val = q[i - 1].val;
			} else {
				q[i].val = sum[i];
				q[i].it = i;
			}	
		}
		//第二类,根本不需要单调队列!!用用动规思想记录下
		//q[i].val 记录从一到i的sum[i]的最大值
		//q[i].it记录q[i].val第一次出现的下标(题目要求的多个答案的输出要求)
		for(i = k + 1;i < n;i++)
		{
			int delta = ALL - sum[i] + q[q[i - k].it].val;
			if(delta > ans)
			{
				ans = delta;
				l = i + 1;
				r = q[i - k].it;
			}
		}
		printf("%d %d %d\n",ans,l,r);
	}
	return 0;
}

猜你喜欢

转载自blog.csdn.net/qq_42421714/article/details/84939296